// CardDlgCntls.cpp : Dialog control handlers for CardDlg
//
 
#include "stdafx.h"
#include "d3dtypes.h"					// Include for RGBA_MAKE macro
#include <ISTBTDDExt.h>
#include "tulsa sample app.h"
#include "mainfrm.h"
#include "CardDlg.h"
#include "config.h"
#include "InitCardDlg.h"
#include "GraphicsOptionsDlg.h"
#include "AnalogVideoEncoderTestDlg.h"
#include "MPEGDecControlDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CCardDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CCardDlg)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_CONFIG, OnConfig)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_EN_CHANGE(IDC_ANALOG_AUD_VOL, OnChangeAnalogAudVol)
	ON_EN_CHANGE(IDC_AUD_DELAY, OnChangeAudDelay)
	ON_BN_CLICKED(IDC_USE_MPEG_AUD, OnUseMpegAud)
	ON_BN_CLICKED(IDC_USE_ANALOG_AUD, OnUseAnalogAud)
	ON_EN_CHANGE(IDC_MPEG_AUD_VOL, OnChangeMpegAudVol)
	ON_CBN_SELENDOK(IDC_PRI_VID_PORT_SRC_YUV, OnSelendokPriVidPortSrcYUV)
	ON_CBN_SELENDOK(IDC_SEC_VID_PORT_SRC_YUV, OnSelendokSecVidPortSrcYUV)
	ON_BN_CLICKED(IDC_BYPASS, OnBypass)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GRAPHICS_OPTIONS, OnGraphicsOptions)
	ON_BN_CLICKED(IDC_VIDEO_ENCODER_OPTIONS, OnVideoEncoderOptions)
	ON_BN_CLICKED(IDC_ACC_ON, OnAccOn)
	ON_BN_CLICKED(IDC_MPEG_DEC_CONTROL, OnMpegDecControl)
	ON_CBN_SELENDOK(IDC_VID_PORT_SRC_RGB, OnSelendokVidPortSrcRGB)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CCardDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	bAutoView = FALSE;
	CPropertyPage::OnLButtonDown(nFlags, point);
}

void CCardDlg::SetAnalogAudioVolume()
{
	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_ANALOG_AUD_VOL_SPIN);
	pSpin->SetPos(m_Config.AudioVolume[AUDIO_ANALOG_IN]);
	pSpin->SetRange(63, 0);

}

void CCardDlg::GetAnalogAudioVolume()
{
	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_ANALOG_AUD_VOL_SPIN);
	m_Config.AudioVolume[AUDIO_ANALOG_IN] = pSpin->GetPos() & 0xffff;
}

void CCardDlg::SetMPEGAudioVolume()
{
	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_MPEG_AUD_VOL_SPIN);
	pSpin->SetPos(m_Config.AudioVolume[AUDIO_MPEG_DEC]);
	pSpin->SetRange(63, 0);
}

void CCardDlg::GetMPEGAudioVolume()
{
	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_MPEG_AUD_VOL_SPIN);
	m_Config.AudioVolume[AUDIO_MPEG_DEC] = pSpin->GetPos() & 0xffff;
}

void CCardDlg::SetAudioSwitch()
{
	switch(m_Config.AudioSource) {
	case AUDIO_MPEG_DEC:
		CheckRadioButton(IDC_USE_ANALOG_AUD, IDC_USE_MPEG_AUD, IDC_USE_MPEG_AUD);
		break;
	case AUDIO_ANALOG_IN:
		CheckRadioButton(IDC_USE_ANALOG_AUD, IDC_USE_MPEG_AUD, IDC_USE_ANALOG_AUD);
		break;
	default:
		break;
	}
}

void CCardDlg::GetAudioSwitch()
{
	switch (GetCheckedRadioButton(IDC_USE_ANALOG_AUD, IDC_USE_MPEG_AUD)) {
	case IDC_USE_ANALOG_AUD:
		m_Config.AudioSource = AUDIO_ANALOG_IN;
		break;
	case IDC_USE_MPEG_AUD:
		m_Config.AudioSource = AUDIO_MPEG_DEC;
		break;
	default:
		break;
	}
}

void CCardDlg::SetVideoSwitch()
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(IDC_PRI_VID_PORT_SRC_YUV);
	pCombo->SetCurSel((int)m_Config.VideoSource[VIDEO_PORT_YUV_PRI]);

	pCombo = (CComboBox*)GetDlgItem(IDC_SEC_VID_PORT_SRC_YUV);
	pCombo->SetCurSel((int)m_Config.VideoSource[VIDEO_PORT_YUV_SEC]);

	pCombo = (CComboBox*)GetDlgItem(IDC_VID_PORT_SRC_RGB);
	pCombo->SetCurSel((int)m_Config.VideoSource[VIDEO_PORT_RGB]);
}

void CCardDlg::GetVideoSwitch()
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(IDC_PRI_VID_PORT_SRC_YUV);
	m_Config.VideoSource[VIDEO_PORT_YUV_PRI] = (VIDEO_SOURCE)pCombo->GetCurSel();

	pCombo = (CComboBox*)GetDlgItem(IDC_SEC_VID_PORT_SRC_YUV);
	m_Config.VideoSource[VIDEO_PORT_YUV_SEC] = (VIDEO_SOURCE)pCombo->GetCurSel();

	pCombo = (CComboBox*)GetDlgItem(IDC_VID_PORT_SRC_RGB);
	m_Config.VideoSource[VIDEO_PORT_RGB] = (VIDEO_SOURCE)pCombo->GetCurSel();
}

void CCardDlg::SetAudioDelay()
{
	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_AUD_DELAY_SPIN);
	pSpin->SetPos(m_Config.AudioDelay);
	pSpin->SetRange(40, 0);
}

void CCardDlg::GetAudioDelay()
{
	CSpinButtonCtrl *pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_AUD_DELAY_SPIN);
	m_Config.AudioDelay = pSpin->GetPos() & 0xffff;
}

void CCardDlg::SetBypassSwitch()
{
	CButton *pButton = (CButton*)GetDlgItem(IDC_BYPASS);
	pButton->SetCheck(m_bBypass);
}

void CCardDlg::GetBypassSwitch()
{
	CButton *pButton = (CButton*)GetDlgItem(IDC_BYPASS);
	m_bBypass = pButton->GetCheck() == 1? TRUE: FALSE;
}

void CCardDlg::SetACCMode()
{
	CButton *pButton = (CButton*)GetDlgItem(IDC_ACC_ON);
	pButton->SetCheck(m_bACCEnable);
}

void CCardDlg::GetACCMode()
{
	CButton *pButton = (CButton*)GetDlgItem(IDC_ACC_ON);
	m_bACCEnable = pButton->GetCheck() == 1? TRUE: FALSE;
}

void CCardDlg::OnChangeAnalogAudVol() 
{
	GetAnalogAudioVolume();
	if (pAudioControl) {
		pAudioControl->SetVolume(AUDIO_ANALOG_IN, m_Config.AudioVolume[AUDIO_ANALOG_IN]);
	}
}

void CCardDlg::OnChangeMpegAudVol() 
{
	GetMPEGAudioVolume();
	if (pAudioControl) {
		pAudioControl->SetVolume(AUDIO_MPEG_DEC, m_Config.AudioVolume[AUDIO_MPEG_DEC]);
	}
}

void CCardDlg::OnUseMpegAud() 
{
	pAudioControl->SetSource(AUDIO_MPEG_DEC);
	m_Config.AudioSource = AUDIO_MPEG_DEC;

	CRect rect;
	GetCntlRect(IDC_AUD_SWITCH, rect);
	InvalidateRect(&rect, FALSE);
}

void CCardDlg::OnUseAnalogAud() 
{
	pAudioControl->SetSource(AUDIO_ANALOG_IN);
	m_Config.AudioSource = AUDIO_ANALOG_IN;

	CRect rect;
	GetCntlRect(IDC_AUD_SWITCH, rect);	
	InvalidateRect(&rect, FALSE);
}

void CCardDlg::OnSelendokPriVidPortSrcYUV() 
{
	GetVideoSwitch();
	pVideoControl->SetVideoPortSource(VIDEO_PORT_YUV_PRI, m_Config.VideoSource[VIDEO_PORT_YUV_PRI]);

	CRect rect;
	GetCntlRect(IDC_VID_SWITCH, rect);
	InvalidateRect(&rect, FALSE);
}

void CCardDlg::OnSelendokSecVidPortSrcYUV() 
{
	GetVideoSwitch();
	pVideoControl->SetVideoPortSource(VIDEO_PORT_YUV_SEC, m_Config.VideoSource[VIDEO_PORT_YUV_SEC]);

	CRect rect;
	GetCntlRect(IDC_VID_SWITCH, rect);
	InvalidateRect(&rect, FALSE);
}

void CCardDlg::OnSelendokVidPortSrcRGB() 
{
	GetVideoSwitch();
	pVideoControl->SetVideoPortSource(VIDEO_PORT_RGB, m_Config.VideoSource[VIDEO_PORT_RGB]);

	CRect rect;
	GetCntlRect(IDC_VID_SWITCH, rect);
	InvalidateRect(&rect, FALSE);
}


void CCardDlg::OnChangeAudDelay() 
{
	GetAudioDelay();
	if (pAudioControl) {
		pAudioControl->SetDelay(m_Config.AudioDelay);
	}
}

void CCardDlg::OnBypass() 
{
	GetBypassSwitch();
	pBoardControl->EnableBypass(m_bBypass);

	CRect rect;
	GetCntlRect(IDC_AUD_BYPASS_SWITCH, rect);
	InvalidateRect(&rect, FALSE);
	GetCntlRect(IDC_VID_BYPASS_SWITCH, rect);
	InvalidateRect(&rect, FALSE);
}

void CCardDlg::OnAccOn() 
{
	GetACCMode();
	ANALOG_VIDEO_DECODER_CONFIG Config;
	Config.bACCEnable = m_bACCEnable;
	Config.bCtlConfigValid = FALSE;
	Config.bLutConfigValid = FALSE;

	pAnalogVideoDecoderControl->SetConfig(m_Config.VideoMode, &Config);
}

void CCardDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CRect rect;

	GetCntlRect(IDC_AUD_SWITCH, rect);

	if (m_Config.AudioSource < 2) {
		m_PictureAudSwitch[m_Config.AudioSource].Render(&dc, rect, rect);
	}

	int VidPicture = m_Config.VideoSource[VIDEO_PORT_YUV_PRI] | 
		(m_Config.VideoSource[VIDEO_PORT_YUV_SEC] << 1) |
		(m_Config.VideoSource[VIDEO_PORT_RGB] << 2);
	GetCntlRect(IDC_VID_SWITCH, rect);
	if (VidPicture < NUM_VID_SWITCH_BMPS) {
		m_PictureVidSwitch[VidPicture].Render(&dc, rect, rect);
	}

	if (m_bBypass) {
		GetCntlRect(IDC_AUD_BYPASS_SWITCH, rect);
		m_PictureAudBypass[0].Render(&dc, rect, rect);
		GetCntlRect(IDC_VID_BYPASS_SWITCH, rect);
		m_PictureVidBypass[0].Render(&dc, rect, rect);
	} else {
		GetCntlRect(IDC_AUD_BYPASS_SWITCH, rect);
		m_PictureAudBypass[1].Render(&dc, rect, rect);
		GetCntlRect(IDC_VID_BYPASS_SWITCH, rect);
		m_PictureVidBypass[1].Render(&dc, rect, rect);
	}

}

